/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");	
	
	cambio=0; //Contador que controla el cambio de fotograma
	fotograma=0; //Numero de fotograma a dibujars
	
	depurar=0;
	boton_depurar = document.getElementById("boton_depurar"); //boton de depurar

	//Anadimos los listener para los eventos
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	canvas.addEventListener('mousedown', mouse_down, false);
	
	down=0;
	down_time=0;
	
	//Inicializamos el jugador
	jugador=new Jugador(23);
	//Inicializamos el escenario
	escenario=new Escenario(1);
	
	posX=Math.round(escenario.xini);
	posY=Math.round(escenario.yini);
	ruta=new Ruta(jugador.getX(),jugador.getY(),jugador.getX(),jugador.getY(),0,0);
	
	tag_destacado=-1;
	objeto_destacado=-1;
	
	
	//Bocadillos
	bocadillos=new Array(1);
	bocadillos[0]=new Bocadillo("contestador",44,8,60,50);
	
	cerrar_destacado=-1;
	contexto.lineWidth = 2; //Grosor
	
	//Creamos el menu
	menu=new Menu(50,50);
	menu_button_pointed=-1;
	
	//Inicializamos el chooser
	chooser=new Chooser(0,0,0,0,-1);
	
	//Inicializamos el dialogo
	dialogo=new Dialogo(0,0,0,0,-1);
	
	//Inicializamos el sobre de peticion
	band_requests=new BandRequests(105,20);
	boton_destacado=-1;
	
	//Progreso de la carga
	total=6+jugador.cuerpo_img.length+bocadillos.length+menu.botones.length*2;
	for(i=0;i<escenario.objetos.length;i++)
		for(j=0;j<escenario.objetos[i].length;j++)
			total++;
	trozo=100/total;
	progreso=1;
	jugador.cara_img.onload = function() {progreso+=trozo;}
	jugador.rastro_img.onload = function() {progreso+=trozo;}
	jugador.sombra_img.onload = function() {progreso+=trozo;}
	escenario.fondo_img.onload = function() {
		progreso+=trozo;
		tam_image_square_x=escenario.fondo_img.width/GRID_COLUMNS;
		tam_image_square_y=escenario.fondo_img.height/GRID_ROWS;
	}
	jugador.cuerpo_img[0].onload = function() {progreso+=trozo;}	
	for(i=0;i<escenario.objetos.length;i++)	for(j=0;j<escenario.objetos[i].length;j++)
			escenario.objetos[i][j].objeto_img.onload = function() {progreso+=trozo;}
	for(i=0;i<bocadillos.length;i++) bocadillos[i].bocadillo_img.onload = function() {progreso+=trozo;}
	for(i=0;i<menu.botones.length;i++){
		menu.botones[i].image.onload = function() {progreso+=trozo;}
		menu.botones[i].over_image.onload = function() {progreso+=trozo;}
	}
	band_requests.boton.image.onload = function() {progreso+=trozo;}
	band_requests.boton.over_image.onload = function() {progreso+=trozo;}
	
	//Para lanzar el fadein
	fadein_alpha=1.0;
	//Para lanzar el fadeout
	fadeout_alpha=1.0;
	
	//Lanzamos el evento draw_progressbar
	interval=setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
	
	//Bloqueamos el control incialmente
	bloquear();
}

function run(){
	animar();
	dibujar();
}

function animar(){
		
	//Calculamos la escala el personaje
	jugador.escala=posY/ALTURA_EFECTIVA+0.5;
	//Animamos al personaje
	if(jugador.direccion_x==1)
		if(jugador.getX()>ruta.getX())
			posX-=MAX_VELOCIDAD;
		else
			jugador.direccion_x=0;
	else if(jugador.direccion_x==2)
		if(jugador.getX()<ruta.getX())
			posX+=MAX_VELOCIDAD;
		else
			jugador.direccion_x=0;
			
	if(jugador.direccion_y==1)
		if(jugador.getY()>ruta.getY())
			posY-=MAX_VELOCIDAD;
		else
			jugador.direccion_y=0;			
	else if(jugador.direccion_y==2)
		if(jugador.getY()<ruta.getY())
			posY+=MAX_VELOCIDAD;
		else
			jugador.direccion_y=0;
	
		
	//Calculamos el fotograma
	if(jugador.direccion_x!=0 || jugador.direccion_y!=0){ //Se esta moviendo
		if(cambio<=0){
			fotograma=(fotograma+1)%(jugador.cuerpo_img.length);
			cambio=MAX_CAMBIO_FOTOGRAMA;
		}else{
			cambio-=INTERVALO_REFRESCAR_PANTALLA;
		}		
	}else{
		if(ruta.finalizada()){
			cambio=0;
			fotograma=0;
		}
	}
	
	//Menu
	if(menu.estado==DESPLEGAR_MENU){
        if(menu.y<MAX_MENU_HIGHT)   menu.y++;
    }else if(menu.estado==REPLEGAR_MENU){
        if(menu.y>0){
            menu.y--;
        }else{
            menu.estado=MENU_INACTIVO;
			//Marcamos las casillas para no redibujarlas
			dibujar_fondo();
        }
    }
	
	//Time the mouse is pressed
	if(down && down_time<MAX_DOWN_TIME){
		down_time++;
	}
}

function dibujar() {

	if(progreso<100){
		draw_progressbar();
	}else{

		dibujar_fondo();
			
		//Controlamos si el jugador esta pasando por delante o por detras de un objeto
		dibujar_sobre(); //Dibujamos el sobre si hay peticiones
		dibujar_objetos_detras(); //Dibujamos los objetos que se encuentran detras del personaje
		dibujar_rastro(); //dibujamos, si procede, el rastro del personaje
		dibujar_jugador(); //pintamos el jugador			
		dibujar_objetos_delante(); //Dibujamos los objetos que se encuentran delante del personaje
		
		dibujar_bocadillos(); //Dibujamos los bocadillos activos
		dibujar_chooser();
		dibujar_dialogo();
		
		//Depuramos si hemos activado el modo depurar
		if(depurar){
			dibujar_depurar();
		}
			
		dibujar_menu();	
		draw_fadein();
		draw_fadeout();
	}
}

function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_area.style.visibility="visible";
		document.formulario.texto_direccion.style.visibility="visible";
		document.formulario.texto_xpos.style.visibility="visible";
		document.formulario.texto_ypos.style.visibility="visible";
		document.formulario.texto_xdest.style.visibility="visible";
		document.formulario.texto_ydest.style.visibility="visible";
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_area.style.visibility="hidden";
		document.formulario.texto_direccion.style.visibility="hidden";
		document.formulario.texto_xpos.style.visibility="hidden";
		document.formulario.texto_ypos.style.visibility="hidden";
		document.formulario.texto_xdest.style.visibility="hidden";
		document.formulario.texto_ydest.style.visibility="hidden";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function posicion_relativa(x0,y0,x1,y1,x2,y2){
	
	var d=(y2-y1)*x0+(x1-x2)*y0+(x2*y1-y2*x1);
	
	return d<=0;
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function calcular_area(x){
	var a=escenario.area.length-1; //Area en el que estamos
	
	while(a>0 && x<escenario.area[a][0])
		a--;
		
	return a;
}

function destacar_objeto(x,y){
	var i;
	tag_destacado=-1;
	objeto_destacado=-1;
	for(i=0;i<escenario.objetos.length && objeto_destacado==-1;i++){
		for(j=0;j<escenario.objetos[i].length;j++){
			if(i!=TAG_GUITAR || j==escenario.guitarra_activa){
				var x1=escenario.objetos[i][j].x;
				var y1=escenario.objetos[i][j].y;
				var x2=escenario.objetos[i][j].x+escenario.objetos[i][j].width*escenario.objetos[i][j].escala;
				var y2=escenario.objetos[i][j].y+escenario.objetos[i][j].height*escenario.objetos[i][j].escala;
				
				if(x>=x1 && x<=x2 && y>=y1 && y<=y2){
					tag_destacado=i;
					objeto_destacado=j;
				}
			}
		}
	}
}

function destacar_botones(x,y){
	boton_destacado=-1;
	var x1=band_requests.boton.x;
	var y1=band_requests.boton.y;
	var x2=x1+band_requests.boton.w;
	var y2=y1+band_requests.boton.h;

	if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
			boton_destacado=0;
}

function destacar_botones_menu(x,y){
	menu_button_pointed=-1;
	var i;
	for(i=0;i<menu.botones.length && menu_button_pointed==-1;i++){
		var x1=menu.botones[i].x;
		var y1=menu.y;
		var x2=x1+menu.botones[i].w;
		var y2=y1+menu.botones[i].h;

		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
				menu_button_pointed=i;
	}
}

function repartir_elementos(x,y,n,c,w,h,m){
	var coordenadas=new Array(n);	
	var n_filas=Math.floor(n/c)+(n%c!=0);
	var tam_columna=n_filas*h+(n_filas-1)*m;
	var y_fila=y-tam_columna/2;
	
	var i=0;
	while(i<n){
		var tanda=n-i;
		if(tanda>3)tanda=3;
		var tam_fila=tanda*w+(tanda-1)*m;
		var x_fila=x-tam_fila/2;
		for(j=0;j<tanda;j++){
			coordenadas[i+j]=new Array(2);
			coordenadas[i+j][0]=x_fila;
			coordenadas[i+j][1]=y_fila;
			x_fila+=w+m;
		}
		y_fila+=h+m;
		i+=3;
	}
	
	return coordenadas;
}

function jugador_detras_objeto(objeto){
	return jugador.getY()<objeto.y+objeto.height*objeto.escala;
}

function adaptar_x_evento(evento){
    
    if (evento.layerX || evento.layerX == 0) { // Mozilla
        return evento.layerX-ANCHURA_NAVEGADOR/2+ANCHURA_VENTANA/2;
    } else if (evento.offsetX || evento.offsetX == 0) { // Opera
        return evento.offsetX-ANCHURA_NAVEGADOR/2+ANCHURA_VENTANA/2;        
    }
    
    else return -1; //Error    
}

function adaptar_y_evento(evento){
    
    if (evento.layerX || evento.layerX == 0) { // Mozilla
        return evento.layerY-20;
    } else if (evento.offsetX || evento.offsetX == 0) { // Opera
        return evento.offsetY-20;        
    }
    
    else return -1; //Error    
}

function clean_grid(c1,r1,c2,r2){
	var i,j;
	for(i=r1;i<=r2;i++)
		for(j=c1;j<=c2;j++)
			escenario.grid[i][j]=0;
}

function mark_grid(c1,r1,c2,r2){
	var i,j;		
	for(i=r1;i<=r2;i++)
		for(j=c1;j<=c2;j++)
			escenario.grid[i][j]=1;
}

function clean_grid_area(x1,y1,x2,y2){
	var c1=Math.floor(x1/TAM_GRID_SQUARE_X);
	var c2=Math.floor(x2/TAM_GRID_SQUARE_X);
	var r1=Math.floor(y1/TAM_GRID_SQUARE_Y);
	var r2=Math.floor(y2/TAM_GRID_SQUARE_Y);
		
	clean_grid(c1,r1,c2,r2);
}

function mark_grid_area(x1,y1,x2,y2){
	var c1=Math.floor(x1/TAM_GRID_SQUARE_X);
	var c2=Math.floor(x2/TAM_GRID_SQUARE_X);
	var r1=Math.floor(y1/TAM_GRID_SQUARE_Y);
	var r2=Math.floor(y2/TAM_GRID_SQUARE_Y);
		
	mark_grid(c1,r1,c2,r2);
}

function bloquear(){blok=1;}
function desbloquear(){blok=0;}

function redireccionar(url){location.href=url;}

function lanzar_chooser(x,y,tag){
	chooser=new Chooser(x,y,350,200,tag);
	mark_grid(6,1,GRID_COLUMNS-1,5);
}

function lanzar_dialogo(x,y,tag){
	dialogo=new Dialogo(x,y,300,200,tag);
	//mark_grid(6,1,GRID_COLUMNS-1,5);
}

function separar_palabras(texto){
	var separadas=new Array();
	var i;
	var palabra="";
	for(i=0;i<texto.length;i++){
		if(texto[i]!=" "){
			palabra=palabra+texto[i];
		}else{
			separadas[separadas.length]=palabra;
			palabra="";
		}
	}
	separadas[separadas.length]=palabra;
	
	return separadas;
}

function repartir_texto(palabras,w){
	var i=0;
	var lineas=new Array();
	
	while(i<palabras.length){
		var nueva_linea=palabras[i];
		i++;
		while(i<palabras.length && contexto.measureText(nueva_linea+" "+palabras[i]).width<w){
			nueva_linea=nueva_linea+" "+palabras[i];
			i++;
		}
		lineas[lineas.length]=nueva_linea;
	}
	
	return lineas;
}

function dibujar_texto(texto,x_ini,y_ini,w,h,m_x,m_y,al){
	
	var separadas=separar_palabras(texto);
	var repartidas=repartir_texto(separadas,w);
	
	if(al==AL_IZQ){
		var i;
		var y=y_ini+15;
		for(i=0;i<repartidas.length;i++){
			contexto.fillText(repartidas[i], x_ini, y);
			y+=m_y;
		}
	}else if(al==AL_DER){
		var i;
		var y=y_ini+15;
		for(i=0;i<repartidas.length;i++){
			var x=x_ini+w-contexto.measureText(repartidas[i]).width;
			contexto.fillText(repartidas[i], x, y);
			y+=m_y;
		}
	}else if(al==AL_CEN){
		var i;
		var y=y_ini+15;
		for(i=0;i<repartidas.length;i++){
			var linea_w=contexto.measureText(repartidas[i]).width;
			var x=x_ini+w/2-linea_w/2;
			contexto.fillText(repartidas[i], x, y);
			y+=m_y;
		}
	}
}
